--
-- Cmasta's Edited Version to allow radial tool search.
-- Search functions and menu
--

if CLIENT then
	local FindPanel
	local FindEntry
	local ResultLabel2
	local FrameWidth = 192
	local ItemHeight = 16
	local MaxItems = 10

	local function RefreshButtons()
		local Size = table.Count( Results )
		local Text = ""
		if Size > MaxItems then Text = "And " .. tostring( Size - MaxItems ) .. " results not listed." end
		ResultLabel2:SetText( Text )
		for k2, v2 in pairs(SToolButtons) do
			v2:Remove()
		end
		SToolButtons = {}
		local i = 0
		for k2, v2 in pairs( Results ) do
			i = i + 1
			local Button = vgui.Create( "Button" )
			Button:SetParent( FindPanel )
			Button:SetPos( 8, 72 + ( i - 1 ) * ItemHeight )
			Button:SetSize( FindPanel:GetWide() - 16, ItemHeight )
			Button:SetContentAlignment( 4 )
			if v2[ 2 ] then
				Button:SetText( string.gsub( v2[ 2 ] .. " - " .. k2, "#", "" ) )
			else
				Button:SetText( k2 )
			end
			Button.Tool = v2[ 1 ]
			function Button:DoClick() 
				PasteConvar(tostring(self.Tool)) --Write Convar to textbox in options menu. Cmasta.
				FindPanel:SetVisible(false) -- Remove Search box. Cmasta.
			end
			table.insert( SToolButtons, Button ) 
			if i >= MaxItems then break end
		end
	end

	local function CreateVGUI()

		FindPanel = vgui.Create( "DFrame" )
		FindPanel:SetSize( FrameWidth, 256 )
		FindPanel:SetTitle( "" )
		FindPanel:SetDeleteOnClose( false )
		FindPanel:ShowCloseButton( true )
		FindPanel:SetDraggable( false )
		FindPanel:SetSizable( false )
		FindPanel:MakePopup()
		FindPanel:SetKeyboardInputEnabled( true )
		FindPanel:SetMouseInputEnabled( true )

		function FindPanel:Paint()

			draw.RoundedBox( 8, 0, 0, self:GetWide(), self:GetTall(), Color( 64, 64, 64, 192 ) )
			draw.RoundedBox( 8, 6, 70, self:GetWide() - 12, self:GetTall() - 76, Color( 24, 24, 24, 192 ) )

		end

		FindEntry = vgui.Create( "TextEntry" )
		FindEntry:SetParent( FindPanel )
		FindEntry:SetPos( 80, 36 )
		FindEntry:SetSize( 96, 24 )
		FindEntry.Value = ""

		function FindEntry:Think()

			local Value = self:GetValue()

			if not ( self.Value == Value ) then

				self.Value = Value

				Results = {}

				if not ( Value == "" ) then

					local TOOLS = ents.FindByClass( "gmod_tool" )[ 1 ].Tool

					if TOOLS then

						for Tool, v2 in pairs( TOOLS ) do

							local Found = true

							local Name = v2.Name or "#" .. Tool
							local Category = v2.Category

							local Explode = string.Explode( " " , Value )

							for j, c in pairs( Explode ) do

								if not ( string.find( string.lower( Tool ), string.lower( c ) ) or string.find( string.lower( Name ), string.lower( c ) ) or string.find( string.lower( Category or "" ), string.lower( c ) ) ) then

									Found = false

								end

							end

							if Found then

								Results[ Name ] = { Tool, Category }

							end

						end

					end

				end

				RefreshButtons()

			end

		end

		ResultLabel2 = vgui.Create( "Label" )
		ResultLabel2:SetParent( FindPanel )
		ResultLabel2:SetPos( FindPanel:GetWide() * .5 - 56, FindPanel:GetTall() - 24 )
		ResultLabel2:SetSize( 128, 16 )
		ResultLabel2:SetText( "" )

		local TitleLabel = vgui.Create( "Label" )
		TitleLabel:SetParent( FindPanel )
		TitleLabel:SetPos( 24, 8 )
		TitleLabel:SetSize( 64, 16 )
		TitleLabel:SetText( "Find Tool" )

		local Label = vgui.Create( "Label" )
		Label:SetParent( FindPanel )
		Label:SetPos( 16, 40 )
		Label:SetSize( 64, 16 )
		Label:SetText( "Search for:" )

		ToolFindPanelInvisible()

	end

	timer.Simple( 0, CreateVGUI )

	local function PanelVisible()

		for k2, v2 in pairs( SToolButtons ) do

			v2:Remove()

		end

		FindEntry:RequestFocus()
		FindEntry:SetText( "" )

		FindPanel:SetVisible( true )
		FindPanel:SetPos( ScrW() - 48 - FrameWidth, math.Clamp( ScrH() - 32 - FindPanel:GetTall(), 0, ScrH() ) )

		gui.SetMousePos( ScrW() - 48 - FrameWidth * .5, ScrH() - 32 - FindPanel:GetTall() + 72 + ItemHeight * .5 )

	end

	function ToolFindPanelInvisible()

		FindPanel:SetVisible( false )

		gui.EnableScreenClicker( false )

	end

	function ToolSearch()

		if not FindPanel:IsVisible() then

			PanelVisible()

		end

	end

end