--
-- GB Radial Menu
-- Options Menu
--

if CLIENT then
	local settingsPanelShown = false
	local selectedListTool = nil -- Currently selected tool (Really not nice to do in a global, but doesn't seem like theres any other way

	-- Add the current toolset to the listbox
	local function addToolsToListbox(listbox)
		-- Add tools to listbox
		local listboxTools = {}

		for k,v in pairs(radialConfigTools) do
			listboxTools[k] = vgui.Create("DButton")
			listboxTools[k]:SetDrawBorder(false)
			listboxTools[k]:SetText(v.name)
			listboxTools[k]:SizeToContents()
			listboxTools[k].DoClick = function()
				if selectedListTool ~= nil then
					-- A tool was selected prior
					listboxTools[selectedListTool]:SetSelected(false)
					selectedListTool = k
					listboxTools[selectedListTool]:SetSelected(true)
				else
					-- No tool was selected
					selectedListTool = k
					listboxTools[selectedListTool]:SetSelected(true)
				end
			end

			-- Add the item to the listbox
			listbox:AddItem(listboxTools[k])	
		end
		
		-- If a tool is selected, draw it
		if selectedListTool ~= nil then
			listboxTools[selectedListTool]:SetSelected(true)
		end
	end
	
	--Set convar textbox to tool convar
	function PasteConvar( str2 )
		settingsPanelAddToolsRconText:SetText( "Tool_" .. str2 )
		settingsPanelAddToolsNameText:SetText("")
		settingsPanelAddToolsNameText:RequestFocus()
	end
	
	--[[
	function EditTool()
		if selectedListTool ~= nil then
		settingsPanelAddToolsRconText:SetText(radialConfigTools[selectedListTool].rconcommand)
		settingsPanelAddToolsNameText:SetText(radialConfigTools[selectedListTool].name)
			--radialConfigTools[selectedListTool] = { name = toolName, rconcommand = toolRCon}
		end
	end
	--]]
	--[[
	function settingsPanel:Think()
		if selectedListTool ~= nil then
			local temp2 = nil
			temp2 = radialConfigTools[selectedListTool].rconcommand
			settingsPanelAddToolsRconText:SetText(tostring(temp2))
		end
	end
	--hook.Add( "Think", "Tool Search Think", ToolThink )
	--]]
	
	function openRadialMenuConfig()
		-- Build our own menu, because the AddControl function doesn't seem to be able to call LUA functions, but only concommands :(
		-- Do I have to tell you how "#/%&"%&" annoying that is?
		local settingsSizeX = 200
		local settingsSizeY = 430
		local objSizeX, objSizeY, objPosX, objPosY
		local edited = 0
		
		-- If the settings aren't shown yet, show them
		if not settingsPanelShown then
			-- Base frame
			settingsPanel = vgui.Create("DFrame")
			settingsPanel:SetSize(settingsSizeX, settingsSizeY)
			settingsPanel:SetTitle("Radial Menu Settings")
			settingsPanel:SetVisible(true)
			settingsPanel:ShowCloseButton(false)
			settingsPanel:SetDeleteOnClose(true)

			-- Deadzone?
			local settingsPanelDeadzone = vgui.Create("DNumSlider", settingsPanel)
			settingsPanelDeadzone:SetText("Menu Deadzone")
			settingsPanelDeadzone:SetPos(6, 27)
			objSizeX, objSizeY = settingsPanelDeadzone:GetSize()	-- Used to scale size so it fills the entire window
			settingsPanelDeadzone:SetSize(settingsSizeX - 12, objSizeY)
			settingsPanelDeadzone:SetMinMax(1, 200)
			settingsPanelDeadzone:SetDecimals(0)			
			settingsPanelDeadzone:SetValue(radialConfig["gbr-menudeadzone"])			
			settingsPanelDeadzone.ValueChanged = function()
				radialConfig["gbr-menudeadzone"] = settingsPanelDeadzone:GetValue()
			end			

			objPosX, objPosY = settingsPanelDeadzone:GetPos()	-- Used for placing the next component

			-- Labels equally sized or individually sized??
			local settingsPanelLabelSize = vgui.Create("DCheckBoxLabel", settingsPanel)
			settingsPanelLabelSize:SetText("Labels sized individually")
			settingsPanelLabelSize:SizeToContents()
			settingsPanelLabelSize:SetPos(6, objPosY + objSizeY + 8)
			settingsPanelLabelSize:SetValue(radialConfig["gbr-menulabelssizedindividually"])			
			settingsPanelLabelSize.OnChange = function()
				if settingsPanelLabelSize:GetChecked() then radialConfig["gbr-menulabelssizedindividually"] = 1 else radialConfig["gbr-menulabelssizedindividually"] = 0 end
			end

			objSizeX, objSizeY = settingsPanelLabelSize:GetSize()	-- Used for placing the next component
			objPosX, objPosY = settingsPanelLabelSize:GetPos()	-- Used for placing the next component

			-- Draw traceline?
			local settingsPanelDrawTraceline = vgui.Create("DCheckBoxLabel", settingsPanel)
			settingsPanelDrawTraceline:SetText("Draw selector traceline")
			settingsPanelDrawTraceline:SizeToContents()
			settingsPanelDrawTraceline:SetPos(6, objPosY + objSizeY + 4)
			settingsPanelDrawTraceline:SetValue(radialConfig["gbr-menushowtraceline"])			
			settingsPanelDrawTraceline.OnChange = function()
				if settingsPanelDrawTraceline:GetChecked() then radialConfig["gbr-menushowtraceline"] = 1 else radialConfig["gbr-menushowtraceline"] = 0 end
			end

			objSizeX, objSizeY = settingsPanelDrawTraceline:GetSize()	-- Used for placing the next component
			objPosX, objPosY = settingsPanelDrawTraceline:GetPos()	-- Used for placing the next component

			-- Show splitters?
			local settingsPanelShowSplitters = vgui.Create("DCheckBoxLabel", settingsPanel)
			settingsPanelShowSplitters:SetText("Show menu splitters")
			settingsPanelShowSplitters:SizeToContents()
			settingsPanelShowSplitters:SetPos(6, objPosY + objSizeY + 4)
			settingsPanelShowSplitters:SetValue(radialConfig["gbr-menushowsplitters"])			
			settingsPanelShowSplitters.OnChange = function()
				if settingsPanelShowSplitters:GetChecked() then radialConfig["gbr-menushowsplitters"] = 1 else radialConfig["gbr-menushowsplitters"] = 0 end
			end

			objSizeX, objSizeY = settingsPanelShowSplitters:GetSize()	-- Used for placing the next component
			objPosX, objPosY = settingsPanelShowSplitters:GetPos()		-- Used for placing the next component
			
			-- Splitterlength?
			local settingsPanelSplitterLength = vgui.Create("DNumSlider", settingsPanel)
			settingsPanelSplitterLength:SetText("Splitter Length")
			settingsPanelSplitterLength:SetPos(6, objPosY + objSizeY + 2)
			objSizeX, objSizeY = settingsPanelSplitterLength:GetSize()
			settingsPanelSplitterLength:SetSize(settingsSizeX - 12, objSizeY)
			settingsPanelSplitterLength:SetMinMax(1, 200)
			settingsPanelSplitterLength:SetDecimals(0)			
			settingsPanelSplitterLength:SetValue(radialConfig["gbr-menusplitterlength"])			
			settingsPanelSplitterLength.ValueChanged = function()
				radialConfig["gbr-menusplitterlength"] = settingsPanelSplitterLength:GetValue()
			end

			objPosX, objPosY = settingsPanelSplitterLength:GetPos()		-- Used for placing the next component
			
			-- Tool Label
			local settingsPanelToolsLabel = vgui.Create("DLabel", settingsPanel)
			settingsPanelToolsLabel:SetText("Tools Setup")
			settingsPanelToolsLabel:SizeToContents()
			settingsPanelToolsLabel:SetPos(6, objPosY + objSizeY + 10)

			objSizeX, objSizeY = settingsPanelToolsLabel:GetSize()	-- Used for placing the next component
			objPosX, objPosY = settingsPanelToolsLabel:GetPos()		-- Used for placing the next component
			
			-- Tool Setup
			local settingsPanelTools = vgui.Create("DPanelList", settingsPanel)
			settingsPanelTools:SetPos(6, objPosY + objSizeY + 2)
			settingsPanelTools:SetSize(settingsSizeX - 12, 100) -- 100 px high
			settingsPanelTools:SetSpacing(2)
			settingsPanelTools:SetPadding(2)
			settingsPanelTools:EnableHorizontal(false)
			settingsPanelTools:EnableVerticalScrollbar(true)
			
			-- Add the current tools to the listbox
			addToolsToListbox(settingsPanelTools)

			objSizeX, objSizeY = settingsPanelTools:GetSize()	-- Used for placing the next component
			objPosX, objPosY = settingsPanelTools:GetPos()		-- Used for placing the next component
			
			-- Add up button
			local settingsPanelMoveUp = vgui.Create("DSysButton", settingsPanel)
			settingsPanelMoveUp:SetType("up")
			settingsPanelMoveUp:SetPos(6, objPosY + objSizeY + 2)
			objSizeX, objSizeY = settingsPanelMoveUp:GetSize()		-- Used to scale size so it fills the entire window
			settingsPanelMoveUp:SetSize(60, objSizeY)
			settingsPanelMoveUp.DoClick = function()
				-- Check if the selected tool is the first
				if selectedListTool ~= nil and selectedListTool > 1 then
					-- Not the first, we do a swap
					local tempTool = radialConfigTools[selectedListTool - 1]
					radialConfigTools[selectedListTool - 1] = radialConfigTools[selectedListTool]
					radialConfigTools[selectedListTool] = tempTool

					selectedListTool = selectedListTool - 1

					-- Clean and redraw the listbox
					settingsPanelTools:Clear()
					
					addToolsToListbox(settingsPanelTools)					
				end
			end

			objPosX, objPosY = settingsPanelMoveUp:GetPos()		-- Used for placing the next component
			
			-- Add delete button
			local settingsPanelDelete = vgui.Create("DSysButton", settingsPanel)
			settingsPanelDelete:SetType("close")
			settingsPanelDelete:SetPos(70, objPosY)
			settingsPanelDelete:SetSize(60, objSizeY)
			settingsPanelDelete.DoClick = function()
				-- Delete the selected tool, if a tool is selected
				if selectedListTool ~= nil then
					radialConfigTools[selectedListTool] = nil
					
					-- Check if index is fragmented
					if not table.IsSequential(radialConfigTools) then
						-- Table needs to be reordered
						local tempToolTable = {}
						local tempToolTableCounter = 1
						
						for k,v in pairs(radialConfigTools) do
							tempToolTable[tempToolTableCounter] = v
							
							tempToolTableCounter = tempToolTableCounter + 1
						end
						
						radialConfigTools = tempToolTable					
						tempToolTable = nil
					end
	
					-- No tool is selected
					selectedListTool = nil
					
					-- Clean and redraw the listbox
					settingsPanelTools:Clear()
					
					addToolsToListbox(settingsPanelTools)
				end
			end
			
			-- Add down button
			local settingsPanelMoveDown = vgui.Create("DSysButton", settingsPanel)
			settingsPanelMoveDown:SetType("down")
			settingsPanelMoveDown:SetPos(134, objPosY)
			settingsPanelMoveDown:SetSize(60, objSizeY)
			settingsPanelMoveDown.DoClick = function()
				-- Check if the selected tool is the last
				if selectedListTool ~= nil and selectedListTool < table.getn(radialConfigTools) then
					-- Not the last, we do a swap
					local tempTool = radialConfigTools[selectedListTool + 1]
					radialConfigTools[selectedListTool + 1] = radialConfigTools[selectedListTool]
					radialConfigTools[selectedListTool] = tempTool
					
					selectedListTool = selectedListTool + 1
					
					-- Clean and redraw the listbox
					settingsPanelTools:Clear()
					
					addToolsToListbox(settingsPanelTools)					
				end
			end
			
			objSizeX, objSizeY = settingsPanelMoveUp:GetSize()	-- Used for placing the next component
			objPosX, objPosY = settingsPanelMoveUp:GetPos()			-- Used for placing the next component			
			
			-- Add Add Tools label
			local settingsPanelAddToolsLabel = vgui.Create("DLabel", settingsPanel)
			settingsPanelAddToolsLabel:SetText("Add tool")
			settingsPanelAddToolsLabel:SizeToContents()
			settingsPanelAddToolsLabel:SetPos(6, objPosY + objSizeY + 10)			

			objSizeX, objSizeY = settingsPanelAddToolsLabel:GetSize()	-- Used for placing the next component
			objPosX, objPosY = settingsPanelAddToolsLabel:GetPos()			-- Used for placing the next component			

			-- Add Tool Name Label
			local settingsPanelAddToolsNameLabel = vgui.Create("DLabel", settingsPanel)
			settingsPanelAddToolsNameLabel:SetText("Name")
			settingsPanelAddToolsNameLabel:SizeToContents()
			settingsPanelAddToolsNameLabel:SetPos(6, objPosY + objSizeY + 6)

			objPosX, objPosY = settingsPanelAddToolsNameLabel:GetPos()			-- Used for placing the next component			
			objSizeX, objSizeY = settingsPanelAddToolsNameLabel:GetSize()	-- Used for placing the next component
			
			-- Add Tool Name Textentry
			settingsPanelAddToolsNameText = vgui.Create("DTextEntry", settingsPanel)
			settingsPanelAddToolsNameText:SetPos(objSizeX + 9, objPosY - 2)
			settingsPanelAddToolsNameText:SetEnterAllowed(false)
			settingsPanelAddToolsNameText:SetTall(16)
			settingsPanelAddToolsNameText:SetWide(settingsSizeX - 15 - objSizeX)

			objSizeX, objSizeY = settingsPanelAddToolsNameText:GetSize()	-- Used for placing the next component
			objPosX, objPosY = settingsPanelAddToolsNameText:GetPos()			-- Used for placing the next component			
			
			-- Add Con Command Label
			local settingsPanelAddToolsRconLabel = vgui.Create("DLabel", settingsPanel)
			settingsPanelAddToolsRconLabel:SetText("Con")
			settingsPanelAddToolsRconLabel:SizeToContents()
			settingsPanelAddToolsRconLabel:SetPos(6, objPosY + objSizeY + 6)

			objPosX, objPosY = settingsPanelAddToolsRconLabel:GetPos()			-- Used for placing the next component			
			objSizeX, objSizeY = settingsPanelAddToolsRconLabel:GetSize()		-- Used for placing the next component

			-- Add Con Command Textentry
			settingsPanelAddToolsRconText = vgui.Create("DTextEntry", settingsPanel)
			settingsPanelAddToolsRconText:SetPos(objSizeX + 10, objPosY - 2)
			settingsPanelAddToolsRconText:SetEnterAllowed(false)
			settingsPanelAddToolsRconText:SetTall(16)
			settingsPanelAddToolsRconText:SetWide(settingsSizeX - 15 - objSizeX)
			objPosX, objPosY = settingsPanelAddToolsRconText:GetPos()			-- Used for placing the next component			
			objSizeX, objSizeY = settingsPanelAddToolsRconText:GetSize()		-- Used for placing the next component
			
			-- Add Add Tool Button
			local settingsPanelAddTool = vgui.Create("DButton", settingsPanel)
			settingsPanelAddTool:SetText("Add")
			settingsPanelAddTool:SetPos(134, objPosY + objSizeY + 8)
			objSizeX, objSizeY = settingsPanelAddTool:GetSize()		-- Used for placing the next component
			settingsPanelAddTool:SetSize(60, objSizeY)
			settingsPanelAddTool.DoClick = function()
				local toolName = settingsPanelAddToolsNameText:GetValue()
				local toolRCon = settingsPanelAddToolsRconText:GetValue()
				
				-- Do we have enough information to add a new tool?
				if #toolName > 0 and #toolRCon > 0 then
					-- Yes we do, add a new tool
					radialConfigTools[#radialConfigTools + 1] = { name = toolName, rconcommand = toolRCon}
					
					-- Clean the entryfields
					settingsPanelAddToolsNameText:SetValue("")
					settingsPanelAddToolsRconText:SetValue("")
					
					-- Clean and redraw the listbox
					settingsPanelTools:Clear()
					
					addToolsToListbox(settingsPanelTools)					
				end
				if edited ~= 0 then
					settingsPanelEditTool:SetText("Edit Tool")
					edited = 0
				end
			end	

			-- Cmasta's Find Tool Con Button
			local settingsPanelFindCon = vgui.Create("DButton", settingsPanel)
			settingsPanelFindCon:SetText("Find Tools")
			settingsPanelFindCon:SetPos(70, objPosY + objSizeY + 2)
			objSizeX, objSizeY = settingsPanelFindCon:GetSize()		-- Used for placing the next component
			settingsPanelFindCon:SetSize(60, objSizeY)
			settingsPanelFindCon.DoClick = function()
				ToolSearch()
				if edited == 1 then
					settingsPanelEditTool:SetText("Edit Tool")
					edited = 0
				end
				settingsPanelAddToolsNameText:SetValue("")
				settingsPanelAddToolsRconText:SetValue("")
			end	

			-- Cmasta's Edit tool button
			settingsPanelEditTool = vgui.Create("DButton", settingsPanel)
			settingsPanelEditTool:SetText("Edit Tool")
			settingsPanelEditTool:SetPos(6, objPosY + objSizeY + 2)
			objSizeX, objSizeY = settingsPanelEditTool:GetSize()		-- Used for placing the next component
			settingsPanelEditTool:SetSize(60, objSizeY)
			settingsPanelEditTool.DoClick = function()
				--EditTool()
				if selectedListTool ~= nil then
					if edited == 0 then
						edited = 1
						settingsPanelAddToolsRconText:SetText(radialConfigTools[selectedListTool].rconcommand)
						settingsPanelAddToolsNameText:SetText(radialConfigTools[selectedListTool].name)
						settingsPanelEditTool:SetText("Save Tool")
					elseif edited == 1 then
						edited = 0
						local TN = settingsPanelAddToolsNameText:GetValue()
						local TC = settingsPanelAddToolsRconText:GetValue()
						radialConfigTools[selectedListTool] = { name = TN, rconcommand = TC}
						settingsPanelTools:Clear()
						addToolsToListbox(settingsPanelTools)	
						settingsPanelEditTool:SetText("Edit Tool")
					end
				end
			end					
			
			-- Save and close button
			local settingsPanelCloseButton = vgui.Create("DButton", settingsPanel)
			settingsPanelCloseButton:SetText("  Close and Save  ")
			settingsPanelCloseButton:SizeToContentsX()
			objSizeX, objSizeY = settingsPanelCloseButton:GetSize()
			settingsPanelCloseButton:SetPos((settingsSizeX / 2) - (objSizeX / 2), settingsSizeY - objSizeY - 5)
			settingsPanelCloseButton.DoClick = function()
				-- Recalculate radial menu layout
				CalculateMenuLayout()
				
				-- Save setup
				saveConfig()
				saveTools()
				
				-- Close the settingspanel
				settingsPanelShown = false
				settingsPanel:Close()
			end
			
			-- Show the settings panel
			settingsPanelShown = true
			settingsPanel:Center()
			settingsPanel:MakePopup()			
		end
	end

	-- Options menu drawing
	function OptionsMenu(optionsPanel)
		-- Spacing
		optionsPanel:AddControl("Label", { Text = "" })
	
		local DButton = vgui.Create("DButton", optionsPanel)
		DButton:SetText("  Open Radial Menu Settings  ")
		DButton:SizeToContentsX()
		DButton:SetPos(7,20)
		DButton.DoClick = openRadialMenuConfig	
	end
	
	-- Actual options menu adding
	function PopulateToolMenu()
		spawnmenu.AddToolMenuOption("Options", "GB Radial Menu", "RadialMenuSettings", "Settings", "", "", OptionsMenu, {})
	end

	-- Add the hook, so we get shown in the Options menu
	hook.Add("PopulateToolMenu", "GBRadialOptions", PopulateToolMenu)
end